// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/RTKStatusV1.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/rtk_status_v1__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__RTKStatusV1__init(microstrain_inertial_msgs__msg__RTKStatusV1 * msg)
{
  if (!msg) {
    return false;
  }
  // gps_tow
  // gps_week
  // epoch_status
  // dongle_version
  // dongle_controller_state
  // dongle_platform_state
  // dongle_controller_status
  // dongle_platform_status
  // dongle_reset_reason
  // dongle_signal_quality
  // gps_correction_latency
  // glonass_correction_latency
  // galileo_correction_latency
  // beidou_correction_latency
  // raw_status_flags
  return true;
}

void
microstrain_inertial_msgs__msg__RTKStatusV1__fini(microstrain_inertial_msgs__msg__RTKStatusV1 * msg)
{
  if (!msg) {
    return;
  }
  // gps_tow
  // gps_week
  // epoch_status
  // dongle_version
  // dongle_controller_state
  // dongle_platform_state
  // dongle_controller_status
  // dongle_platform_status
  // dongle_reset_reason
  // dongle_signal_quality
  // gps_correction_latency
  // glonass_correction_latency
  // galileo_correction_latency
  // beidou_correction_latency
  // raw_status_flags
}

microstrain_inertial_msgs__msg__RTKStatusV1 *
microstrain_inertial_msgs__msg__RTKStatusV1__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__RTKStatusV1 * msg = (microstrain_inertial_msgs__msg__RTKStatusV1 *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__RTKStatusV1), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__RTKStatusV1));
  bool success = microstrain_inertial_msgs__msg__RTKStatusV1__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__RTKStatusV1__destroy(microstrain_inertial_msgs__msg__RTKStatusV1 * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__RTKStatusV1__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__RTKStatusV1__Sequence__init(microstrain_inertial_msgs__msg__RTKStatusV1__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__RTKStatusV1 * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__RTKStatusV1 *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__RTKStatusV1), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__RTKStatusV1__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__RTKStatusV1__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__RTKStatusV1__Sequence__fini(microstrain_inertial_msgs__msg__RTKStatusV1__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__RTKStatusV1__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__RTKStatusV1__Sequence *
microstrain_inertial_msgs__msg__RTKStatusV1__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__RTKStatusV1__Sequence * array = (microstrain_inertial_msgs__msg__RTKStatusV1__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__RTKStatusV1__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__RTKStatusV1__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__RTKStatusV1__Sequence__destroy(microstrain_inertial_msgs__msg__RTKStatusV1__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__RTKStatusV1__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
