// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from microstrain_inertial_msgs:msg/Status.idl
// generated code does not contain a copyright notice
#include "microstrain_inertial_msgs/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
microstrain_inertial_msgs__msg__Status__init(microstrain_inertial_msgs__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // device_model
  // status_selector
  // status_flags
  // system_state
  // system_timer_ms
  // gps_power_on
  // num_gps_pps_triggers
  // last_gps_pps_trigger_ms
  // imu_stream_enabled
  // gps_stream_enabled
  // filter_stream_enabled
  // imu_dropped_packets
  // gps_dropped_packets
  // filter_dropped_packets
  // com1_port_bytes_written
  // com1_port_bytes_read
  // com1_port_write_overruns
  // com1_port_read_overruns
  // imu_parser_errors
  // imu_message_count
  // imu_last_message_ms
  // gps_parser_errors
  // gps_message_count
  // gps_last_message_ms
  return true;
}

void
microstrain_inertial_msgs__msg__Status__fini(microstrain_inertial_msgs__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // device_model
  // status_selector
  // status_flags
  // system_state
  // system_timer_ms
  // gps_power_on
  // num_gps_pps_triggers
  // last_gps_pps_trigger_ms
  // imu_stream_enabled
  // gps_stream_enabled
  // filter_stream_enabled
  // imu_dropped_packets
  // gps_dropped_packets
  // filter_dropped_packets
  // com1_port_bytes_written
  // com1_port_bytes_read
  // com1_port_write_overruns
  // com1_port_read_overruns
  // imu_parser_errors
  // imu_message_count
  // imu_last_message_ms
  // gps_parser_errors
  // gps_message_count
  // gps_last_message_ms
}

microstrain_inertial_msgs__msg__Status *
microstrain_inertial_msgs__msg__Status__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__Status * msg = (microstrain_inertial_msgs__msg__Status *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__Status), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(microstrain_inertial_msgs__msg__Status));
  bool success = microstrain_inertial_msgs__msg__Status__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
microstrain_inertial_msgs__msg__Status__destroy(microstrain_inertial_msgs__msg__Status * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    microstrain_inertial_msgs__msg__Status__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
microstrain_inertial_msgs__msg__Status__Sequence__init(microstrain_inertial_msgs__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__Status * data = NULL;

  if (size) {
    data = (microstrain_inertial_msgs__msg__Status *)allocator.zero_allocate(size, sizeof(microstrain_inertial_msgs__msg__Status), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = microstrain_inertial_msgs__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        microstrain_inertial_msgs__msg__Status__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
microstrain_inertial_msgs__msg__Status__Sequence__fini(microstrain_inertial_msgs__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      microstrain_inertial_msgs__msg__Status__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

microstrain_inertial_msgs__msg__Status__Sequence *
microstrain_inertial_msgs__msg__Status__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  microstrain_inertial_msgs__msg__Status__Sequence * array = (microstrain_inertial_msgs__msg__Status__Sequence *)allocator.allocate(sizeof(microstrain_inertial_msgs__msg__Status__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = microstrain_inertial_msgs__msg__Status__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
microstrain_inertial_msgs__msg__Status__Sequence__destroy(microstrain_inertial_msgs__msg__Status__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    microstrain_inertial_msgs__msg__Status__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}
